import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.*;
import javax.microedition.location.*;

public class a extends MIDlet implements CommandListener, Runnable{
// ***************************************************
 private Command exitCommand;
 private Form f;
 private int upd_time=30;
 private String latitude,longitude;
// ***************************************************
 public a(){
   exitCommand=new Command("Выход",Command.EXIT,0);
 }
// ***************************************************
 public void startApp(){
   f=new Form("Местоположение");
   f.append("Загрузка данных...");
   f.addCommand(exitCommand);
   f.setCommandListener(this);
   Display.getDisplay(this).setCurrent(f);
   (new Thread(this)).start();
 }
// ***************************************************
 public void run(){
   try{
     Criteria c=new Criteria();
     c.setPreferredResponseTime(300000);
     c.setHorizontalAccuracy(1000);
     c.setVerticalAccuracy(1000);
     c.setPreferredPowerConsumption(Criteria.POWER_USAGE_LOW);
     LocationProvider lp=LocationProvider.getInstance(c);
     Location l;
     QualifiedCoordinates qc;
     long time=0;
     long time2;
     while(true){
       time2=System.currentTimeMillis();
       time+=upd_time*1000-time2;
       if(time>0){
         Thread.sleep(time);
         time+=time2;
       }else{
         time=time2;
       }
       try{
         l=lp.getLocation(60);
         if(!l.isValid()) throw new Exception("FFFFFFFFFFUUUUUUUUUU");
         qc=l.getQualifiedCoordinates();
         latitude=Double.toString(qc.getLatitude());
         longitude=Double.toString(qc.getLongitude());
         net.request("http://artcoding.ru/coordinates.php?imei=&time="+
           (time/1000)+"&latitude="+latitude+"&longitude="+longitude);
         f.deleteAll();
         f.append("Время: "+(time/1000)+"\n");
         f.append("Широта: "+latitude+"\n");
         f.append("Долгота: "+longitude+"\n");
       }catch(Exception ex){
         f.deleteAll();
         f.append("Время: "+(time/1000)+"\n");
         f.append("Широта: не определено\n");
         f.append("Долгота: не определено\n");
         f.append("Ошибка: "+ex.toString()+"\n");
       }
     }
   }catch(Exception ex){
     f.append("[EPIC FAIL] "+ex.toString());
   }
 }
// ***************************************************
 public void commandAction(Command c,Displayable s){
   if(c==exitCommand){
     destroyApp(true);
   }
 }
// ***************************************************
 public void pauseApp(){ }
// ***************************************************
 public void destroyApp(boolean u){
   notifyDestroyed();
 }
// ***************************************************
}
